function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import { useRef, useState, createContext } from 'react';
import classnames from 'classnames';
import { Popover } from 'rlj-design';
import FilterBtn from "./FilterBtn";
import FilterContent from "./FilterContent";
import FilterTag from "./FilterTag";
import { PREFIX_CLS } from "../constants/dictionary";
import "./style/index.less";
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var prefixCls = "".concat(PREFIX_CLS, "-filter");
export var FilterContext = /*#__PURE__*/createContext(null);

var Filter = function Filter(props) {
  var overlayClassName = props.overlayClassName,
      trigger = props.trigger,
      btnText = props.btnText,
      btnRender = props.btnRender,
      filterTitle = props.filterTitle,
      filterSecondTitle = props.filterSecondTitle,
      filterNode = props.filterNode,
      showSelectedTag = props.showSelectedTag;
  var filterRef = useRef(null);

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      open = _useState2[0],
      setOpen = _useState2[1];

  return /*#__PURE__*/_jsx(FilterContext.Provider, {
    value: props,
    children: /*#__PURE__*/_jsxs("div", {
      children: [/*#__PURE__*/_jsxs("div", {
        className: prefixCls,
        ref: filterRef,
        children: [/*#__PURE__*/_jsx(Popover, {
          content: /*#__PURE__*/_jsx(FilterContent, {
            filterTitle: filterTitle,
            filterSecondTitle: filterSecondTitle
          }),
          placement: "bottomLeft",
          trigger: trigger,
          overlayClassName: classnames("".concat(prefixCls, "-popover"), overlayClassName),
          getPopupContainer: function getPopupContainer() {
            return filterRef.current;
          },
          open: open,
          onOpenChange: function onOpenChange(open) {
            return setOpen(open);
          },
          children: btnRender ? btnRender : /*#__PURE__*/_jsx(FilterBtn, {
            open: open,
            setOpen: setOpen,
            children: btnText
          })
        }), showSelectedTag && filterNode && /*#__PURE__*/_jsx("div", {
          className: "".concat(filterNode),
          children: filterNode
        })]
      }), /*#__PURE__*/_jsx(FilterTag, {})]
    })
  });
};

Filter.defaultProps = {
  trigger: "click",
  btnText: "筛选",
  unit: '项',
  total: 0
};
export default Filter;