function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useEffect, useMemo, useState, useContext } from 'react';
import { CustomizeIcon, Form } from 'rlj-design';
import FilterValue from "./FilterValue";
import { PREFIX_CLS } from "../constants/dictionary";
import { FilterContext } from "./Filter";
import "./style/filterContent.less";
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
import { Fragment as _Fragment } from "react/jsx-runtime";
var prefixCls = "".concat(PREFIX_CLS, "-filter-content");

var FilterContent = function FilterContent(props) {
  var filterTitle = props.filterTitle,
      filterSecondTitle = props.filterSecondTitle;

  var _useState = useState([]),
      _useState2 = _slicedToArray(_useState, 2),
      selected = _useState2[0],
      setSelected = _useState2[1];

  var _Form$useForm = Form.useForm(),
      _Form$useForm2 = _slicedToArray(_Form$useForm, 1),
      form = _Form$useForm2[0];

  var setFieldsValue = form.setFieldsValue,
      validateFields = form.validateFields;

  var _ref = useContext(FilterContext) || {},
      items = _ref.items;

  useEffect(function () {
    // 默认添加一项
    setFieldsValue({
      fields: [undefined]
    });
  }, []); // 这里给选项打个标，让已经被选择的下拉选项不显示

  var restItems = useMemo(function () {
    return (items || []).map(function (item) {
      return _objectSpread(_objectSpread({}, item), {}, {
        showOption: !selected.includes(item.fieldId)
      });
    });
  }, [selected, items]);

  var onFinish = function onFinish(values) {
    console.log('Received values of form:', values);
  };

  var addNewItem = function addNewItem(add) {
    validateFields().then(function () {
      add();
    }).catch(function (error) {
      console.log(error);
    });
  };

  return /*#__PURE__*/_jsxs(_Fragment, {
    children: [/*#__PURE__*/_jsxs("div", {
      className: "".concat(prefixCls, "-title"),
      children: [filterTitle, /*#__PURE__*/_jsx("span", {
        children: filterSecondTitle
      })]
    }), /*#__PURE__*/_jsx(Form, {
      form: form,
      name: "filter-content",
      onFinish: onFinish,
      autoComplete: "off",
      children: /*#__PURE__*/_jsx(Form.List, {
        name: "fields",
        children: function children(fields, _ref2) {
          var add = _ref2.add,
              remove = _ref2.remove;
          return /*#__PURE__*/_jsxs(_Fragment, {
            children: [fields.map(function (item) {
              return /*#__PURE__*/_jsx(FilterValue, {
                item: item,
                restItems: restItems,
                remove: remove,
                selected: selected,
                setSelected: setSelected
              }, item.key);
            }), /*#__PURE__*/_jsx(Form.Item, {
              children: /*#__PURE__*/_jsxs("a", {
                className: "".concat(prefixCls, "-add"),
                onClick: function onClick() {
                  return addNewItem(add);
                },
                children: [/*#__PURE__*/_jsx(CustomizeIcon, {
                  type: "icon-tianjia"
                }), "\u6DFB\u52A0\u7B5B\u9009\u6761\u4EF6"]
              })
            })]
          });
        }
      })
    })]
  });
};

FilterContent.defaultProps = {
  filterTitle: "筛选",
  filterSecondTitle: "（添加多个筛选条件，可交叉选择）"
};
export default FilterContent;