var _excluded = ["selectedItem", "fun"],
    _excluded2 = ["key", "name"],
    _excluded3 = ["multiselect", "selection"];

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { useState, useContext } from 'react';
import { Input, Form, Select, CustomizeIcon, InputNumber, DatePicker, SelectCheckbox } from 'rlj-design';
import { PREFIX_CLS } from "../constants/dictionary";
import { FilterContext } from "./Filter";
import "./style/filterValue.less";
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var prefixCls = "".concat(PREFIX_CLS, "-filter-value");
var Option = Select.Option;
var RangePicker = DatePicker.RangePicker; // 这里写一个BaseWrapper容器让输入框能够接收到Form.Item给的props属性

var BaseWrapperHOC = function BaseWrapperHOC(_ref) {
  var selectedItem = _ref.selectedItem,
      fun = _ref.fun,
      restProps = _objectWithoutProperties(_ref, _excluded);

  var selection = selectedItem.selection,
      multiSelect = selectedItem.multiSelect;
  return /*#__PURE__*/_jsx("span", {
    children: fun(_objectSpread(_objectSpread({}, restProps), {}, {
      selection: selection,
      multiselect: multiSelect,
      placeholder: '请输入'
    }))
  });
};

var STATUS = {
  string: 'value',
  date: 'range',
  selection: 'selections'
};

var FilterValue = function FilterValue(_ref2) {
  var remove = _ref2.remove,
      item = _ref2.item,
      selected = _ref2.selected,
      setSelected = _ref2.setSelected,
      restItems = _ref2.restItems;

  var _Form$useFormInstance = Form.useFormInstance(),
      setFieldValue = _Form$useFormInstance.setFieldValue,
      getFieldsValue = _Form$useFormInstance.getFieldsValue;

  var key = item.key,
      name = item.name,
      restField = _objectWithoutProperties(item, _excluded2);

  var _useState = useState(),
      _useState2 = _slicedToArray(_useState, 2),
      currentSelected = _useState2[0],
      setCurrentSelected = _useState2[1];

  var _ref3 = useContext(FilterContext) || {},
      filterOk = _ref3.filterOk;

  var onChange = function onChange(e, options) {
    var _options$item = options.item,
        item = _options$item === void 0 ? {} : _options$item;

    var copySelected = _toConsumableArray(selected);

    var _ref4 = currentSelected || {},
        fieldId = _ref4.fieldId;

    var index = fieldId ? copySelected.indexOf(fieldId) : -1;

    if (index >= 0) {
      copySelected.splice(index, 1);
    }

    copySelected.push(e);
    setCurrentSelected(item);
    setSelected(copySelected);
    setFieldValue(['fields', name, 'value'], null);
  };

  var inputComponent = {
    string: function string(restProps) {
      return /*#__PURE__*/_jsx(Input, _objectSpread({
        allowClear: true
      }, restProps));
    },
    number: function number() {
      var restProps = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      return /*#__PURE__*/_jsx(InputNumber, _objectSpread({
        style: {
          width: 206
        },
        maxLength: 16,
        controls: false
      }, restProps));
    },
    date: function date(restProps) {
      return /*#__PURE__*/_jsx(RangePicker, _objectSpread(_objectSpread({
        style: {
          width: '100%'
        },
        allowClear: false
      }, restProps), {}, {
        placeholder: ['开始日期', '结束日期']
      }));
    },
    selection: function selection(_ref5) {
      var multiselect = _ref5.multiselect,
          _selection = _ref5.selection,
          restProps = _objectWithoutProperties(_ref5, _excluded3);

      return multiselect ? /*#__PURE__*/_jsx(SelectCheckbox, _objectSpread({
        options: _selection,
        showSelectAll: false
      }, restProps)) : /*#__PURE__*/_jsx(Select, _objectSpread(_objectSpread({}, restProps), {}, {
        children: _selection && (_selection === null || _selection === void 0 ? void 0 : _selection.map(function (_ref6) {
          var label = _ref6.label,
              value = _ref6.value;
          return /*#__PURE__*/_jsx(Select.Option, {
            value: value,
            children: label
          }, value);
        }))
      }));
    }
  };

  var onBlur = function onBlur() {
    filterOk && filterOk(getFieldsValue());
  };

  return /*#__PURE__*/_jsxs("div", {
    className: "".concat(prefixCls, "-item"),
    children: [/*#__PURE__*/_jsx(Form.Item, _objectSpread(_objectSpread({}, restField), {}, {
      name: [name, 'fieldId'],
      style: {
        width: 160,
        marginRight: 8
      },
      rules: [{
        required: true,
        message: '不能为空'
      }],
      children: /*#__PURE__*/_jsx(Select, {
        onChange: onChange,
        placeholder: "\u8BF7\u9009\u62E9\u5B57\u6BB5",
        allowClear: false,
        optionFilterProp: "children",
        showSearch: true,
        filterOption: function filterOption(input, option) {
          return option.children.toLowerCase().includes(input.toLowerCase());
        },
        children: restItems.map(function (item) {
          return (item.showOption || item.fieldId === (currentSelected === null || currentSelected === void 0 ? void 0 : currentSelected.fieldId)) && /*#__PURE__*/_jsx(Select.Option, {
            value: item.fieldId,
            item: item,
            children: item.fieldName
          }, item.fieldId);
        })
      })
    })), (currentSelected === null || currentSelected === void 0 ? void 0 : currentSelected.fieldType) === 'number' && /*#__PURE__*/_jsx(Form.Item, _objectSpread(_objectSpread({}, restField), {}, {
      name: [name, 'express'],
      style: {
        width: 86,
        marginRight: 8
      },
      rules: [{
        required: true,
        message: '不能为空'
      }],
      children: /*#__PURE__*/_jsxs(Select, {
        style: {
          width: 86,
          marginRight: 8
        },
        placeholder: "\u8BF7\u9009\u62E9",
        children: [/*#__PURE__*/_jsx(Option, {
          value: "=",
          children: "="
        }), /*#__PURE__*/_jsx(Option, {
          value: ">",
          children: ">"
        }), /*#__PURE__*/_jsx(Option, {
          value: "\u2265",
          children: "\u2265"
        }), /*#__PURE__*/_jsx(Option, {
          value: "<",
          children: "<"
        }), /*#__PURE__*/_jsx(Option, {
          value: "\u2264",
          children: "\u2264"
        }), /*#__PURE__*/_jsx(Option, {
          value: "\u2260",
          children: "\u2260"
        })]
      })
    })), /*#__PURE__*/_jsx(Form.Item, _objectSpread(_objectSpread({}, restField), {}, {
      name: [name, STATUS[(currentSelected === null || currentSelected === void 0 ? void 0 : currentSelected.fieldType) || 'string']],
      style: {
        width: (currentSelected === null || currentSelected === void 0 ? void 0 : currentSelected.fieldType) === 'number' ? 206 : 300
      },
      rules: [{
        required: !!currentSelected,
        message: '不能为空'
      }],
      onBlur: onBlur,
      children: !currentSelected ? /*#__PURE__*/_jsx(Input, {
        style: {
          width: 300
        },
        disabled: true
      }) : inputComponent[currentSelected.fieldType] ? /*#__PURE__*/_jsx(BaseWrapperHOC, {
        fun: inputComponent[currentSelected.fieldType],
        selectedItem: currentSelected
      }) : /*#__PURE__*/_jsx(Input, {})
    })), /*#__PURE__*/_jsx("div", {
      className: "".concat(prefixCls, "-delete"),
      children: /*#__PURE__*/_jsx(CustomizeIcon, {
        type: "icon-shanchu",
        size: 16,
        onClick: function onClick() {
          return remove(name);
        }
      })
    })]
  });
};

export default FilterValue;